#!/usr/bin/env python3
# -*- coding: utf-8 -*-

"""Event management module.

Implements:

* class WorldEventManager -- generic event management class.
"""

"""
    The MIT License (MIT)

    Copyright (c) 2015 Raphaël SEBAN

    Permission is hereby granted, free of charge, to any person
    obtaining a copy of this software and associated documentation
    files (the "Software"), to deal in the Software without
    restriction, including without limitation the rights to use, copy,
    modify, merge, publish, distribute, sublicense, and/or sell copies
    of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be
    included in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
    NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
    BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
    ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
    CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.
"""

try:
    from . import world
except:
    import world
# end try


class WorldEventManager (world.WorldItem):
    """Generic event management class.

    As a WorldItem subclass, this can be accessed through e.g.
    self.world.get("worldeventmanager") or any other arbitrary name
    while registering.

    Current implementation does nothing as each external lib has its
    own approach on events handling.

    Please, refer to world.WorldItemInterface implementation for more
    details.

    Feel free to subclass this in order to best meet your own specific
    needs.
    """

    pass # see world.WorldItemInterface for implementation details

# end class
